
USE {Variable_TempDb}
GO

IF exists(select * from sysobjects where id = object_id('[dbo].[__Journal]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
DROP TABLE dbo.[__Journal]
CREATE TABLE dbo.[__Journal] (ID INT IDENTITY(1,1), TITLE nvarchar(254), TEXT nvarchar(max), TABLE_NAME varchar(100), ROWS_NOT_COPIED bigint)
GO


IF exists(select 1 from [{Variable_TempDb}].dbo.sysobjects where id = object_id('[dbo].[__JOURNAL_ACCOUNTS_TO_ADD]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
DROP TABLE [{Variable_TempDb}].dbo.[__JOURNAL_ACCOUNTS_TO_ADD]
GO

DECLARE @dDATE DATETIME
SET @dDATE = DATEADD(YEAR, DATEDIFF(YEAR, 0, GETDATE()), 0) --   

    ---   
DECLARE @MISSED_ACCOUNTS TABLE (cSource VARCHAR(10), cSinth VARCHAR(10), cAnalit VARCHAR(10),msg varchar(254))

INSERT INTO @MISSED_ACCOUNTS (cSource, cSinth, cAnalit, msg)
SELECT sa.cSource, sa.cSinth, sa.cAnalit, sa.CODE + ' : ' + ' : ' + ISNULL(D.CODE,'') + '  : ' + ISNULL(D.INN,'') + '  : ' + LEFT(ISNULL(D.NAME,''),100) 
FROM 
	{Variable_SmetaDb}.dbo.S_ACCOUNTS sa
	LEFT JOIN {Variable_WorkDb}.dbo.S_ACCOUNTS sa2 ON sa2.LINK_DEP = {Variable_WorkDb}.dbo.GETOWNDEPLINK() AND sa2.CODE = CASE WHEN sa.ZABALANS = 1 AND ISNULL(sa.cSource ,'') = '' THEN '0.' + sa.CODE  ELSE sa.CODE  END 
	CROSS APPLY (SELECT DISTINCT ACCOUNT, DEP_LINK FROM {Variable_SmetaDb}.dbo.ARestTableByDate(@dDATE,DEFAULT) WHERE sa.LINK = ACCOUNT) rest
	INNER JOIN {Variable_SmetaDb}.dbo.DEPARTMENTS D ON D.LINK = REST.DEP_LINK AND (D.[TYPE] = 4 OR D.ZB = 1)
WHERE 
	sa2.CODE IS NULL

INSERT INTO @MISSED_ACCOUNTS (cSource, cSinth, cAnalit, msg)
SELECT sa.cSource, sa.cSinth, sa.cAnalit, sa.CODE + ' : ' + ' : ' + ISNULL(D.CODE,'') + '  : ' + ISNULL(D.INN,'') + '  : ' + LEFT(ISNULL(D.NAME,''),100)
FROM 
	{Variable_SmetaDb}.dbo.S_ACCOUNTS sa
	LEFT JOIN {Variable_WorkDb}.dbo.S_ACCOUNTS sa2 ON sa2.LINK_DEP = {Variable_WorkDb}.dbo.GETOWNDEPLINK() AND sa2.CODE = CASE WHEN sa.ZABALANS = 1 AND ISNULL(sa.cSource,'') = '' THEN '0.' + sa.CODE ELSE sa.CODE END
	CROSS APPLY  (SELECT DISTINCT gpa.ACCOUNT, G.DEP FROM {Variable_SmetaDb}.dbo.G_PROV g
					INNER JOIN {Variable_SmetaDb}.dbo.G_PROV1 g1 ON g1.LINK_UP = g.LINK
					INNER JOIN {Variable_SmetaDb}.dbo.G_PROV2 g2 ON g2.LINK_UP = g1.LINK
					INNER JOIN {Variable_SmetaDb}.dbo.G_PROV_AP gpa ON gpa.LINK_UP = g2.LINK
					WHERE g.[DATE] > @dDATE
					AND sa.LINK = gpa.ACCOUNT) prov
	INNER JOIN {Variable_SmetaDb}.dbo.DEPARTMENTS D ON D.LINK = prov.DEP AND (D.[TYPE] = 4 OR D.ZB = 1)                
WHERE 
	sa2.CODE IS NULL
	AND NOT EXISTS (SELECT * FROM @MISSED_ACCOUNTS ma WHERE ma.cSource = sa.cSource AND ma.cSinth = sa.cSinth AND ma.cAnalit = sa.cAnalit)

DECLARE @iROWS_COUNT BIGINT

SELECT DISTINCT cSource, cSinth, cAnalit, msg 
INTO [{Variable_TempDb}].dbo.[__JOURNAL_ACCOUNTS_TO_ADD]
FROM @MISSED_ACCOUNTS
SET @iROWS_COUNT = @@ROWCOUNT

INSERT INTO [{Variable_TempDb}].dbo.[__Journal]
VALUES (' ', '  ', '__JOURNAL_ACCOUNTS_TO_ADD',ISNULL(@iROWS_COUNT,0))


